#!/usr/local/bin/bash

# Copyright (c) 2018-2020, diyIT.org
# All rights reserved.
#
# BSD 2-Clause License ("Simplified BSD License" or "FreeBSD License")
# https://diyit.org/license/
#
#

# ./freebsd.sh under tmux

# clean cached state
bhyvectl --destroy --vm=freebsd

while true
do

bhyve -c 4 -m 8G -A -H -P \
-s 0,hostbridge \
-s 3,ahci-cd \
-s 4,virtio-blk,/dev/zvol/ship/raw/freebsd \
-s 5,virtio-net,tap83,mac=00:0A:0B:0C:0D:83 \
-s 29,fbuf,tcp=0.0.0.0:5983,w=1600,h=900 \
-s 30,xhci,tablet \
-s 31,lpc -l com1,/dev/nmdm83A \
-l bootrom,/usr/local/share/uefi-firmware/BHYVE_UEFI.fd \
freebsd

bhyve_exit=$?
# bhyve returns the following status codes:
#  0 - VM has been reset
#  1 - VM has been powered off
#  2 - VM has been halted
#  3 - VM generated a triple fault
#  all other non-zero status codes are errors
#
if [ $bhyve_exit = 1 ] || [ $bhyve_exit = 2 ]
then
    break
fi
echo `date` - restarting freebsd in 5 seconds - press ctrl-c to stop
sleep 5

done

exit $?

#-s 3,ahci-cd \
#-s 3,ahci-cd,/mnt/freebsd/FreeBSD-12.1-RELEASE-amd64-disc1.iso \
# set boot_serial=NO
# first in boot menu option 3 and then /boot/loader.conf after install

# bhyvectl --get-all --vm=freebsd

# cu -l /dev/nmdm83B
# (This uses cu() so press ~+Ctrl-D to exit)

#on base system:
#zfs create -V 32G -o refreservation=none ship/raw/freebsd
# on boot
#ifconfig tap83 create
#ifconfig bridge1 addm tap83 up
#ifconfig tap83 up
#ifconfig tap83 inet6 auto_linklocal
